import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit. Works in DrJava, not Eclipse
 */
public class AnglicizeTester extends TestCase {
    
    public void testAnglicize() {
        assertEquals("one", Anglicize.anglicize(1));
         assertEquals("nineteen", Anglicize.anglicize(19));
         assertEquals("twenty", Anglicize.anglicize(20));
         assertEquals("thirty five", Anglicize.anglicize(35));
         assertEquals("fifty", Anglicize.anglicize(50));
         assertEquals("ninety nine", Anglicize.anglicize(99));
         assertEquals("one hundred", Anglicize.anglicize(100));
         assertEquals("three hundred one", Anglicize.anglicize(301));
         assertEquals("nine hundred ninety nine", Anglicize.anglicize(999));
         assertEquals("one thousand", Anglicize.anglicize(1000));
         assertEquals("one thousand nine", Anglicize.anglicize(1009));
         assertEquals("nine hundred thousand", Anglicize.anglicize(900000));
         assertEquals("seven hundred eighty nine thousand four hundred thirty six",
                          Anglicize.anglicize(789436));
    }
    
    public void testAng19() {
        assertEquals("one", Anglicize.ang19(1));
        assertEquals("two", Anglicize.ang19(2));
        assertEquals("three", Anglicize.ang19(3));
        assertEquals("four", Anglicize.ang19(4));
        assertEquals("five", Anglicize.ang19(5));
        assertEquals("six", Anglicize.ang19(6));
        assertEquals("seven", Anglicize.ang19(7));
        assertEquals("eight", Anglicize.ang19(8));
        assertEquals("nine", Anglicize.ang19(9));
        assertEquals("ten", Anglicize.ang19(10));
        assertEquals("eleven", Anglicize.ang19(11));
        assertEquals("twelve", Anglicize.ang19(12));
        assertEquals("thirteen", Anglicize.ang19(13));
        assertEquals("fourteen", Anglicize.ang19(14));
        assertEquals("fifteen", Anglicize.ang19(15));
        assertEquals("sixteen", Anglicize.ang19(16));
        assertEquals("seventeen", Anglicize.ang19(17));
        assertEquals("eighteen", Anglicize.ang19(18));
        assertEquals("nineteen", Anglicize.ang19(19));
    }
    
    public void testTens() {
         assertEquals("twenty", Anglicize.tens(2));
         assertEquals("thirty", Anglicize.tens(3));
         assertEquals("forty", Anglicize.tens(4));
         assertEquals("fifty", Anglicize.tens(5));
         assertEquals("sixty", Anglicize.tens(6));
         assertEquals("seventy", Anglicize.tens(7));
         assertEquals("eighty", Anglicize.tens(8));
         assertEquals("ninety", Anglicize.tens(9));
        
    }
    
}
